/* dswap.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int dswap_(n, dx, incx, dy, incy)
integer *n;
doublereal *dx;
integer *incx;
doublereal *dy;
integer *incy;
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static integer i__, m;
    static doublereal dtemp1, dtemp2, dtemp3;
    static integer ix, iy, ns, mp1;

/* ***BEGIN PROLOGUE  DSWAP */
/* ***DATE WRITTEN   791001   (YYMMDD) */
/* ***REVISION DATE  820801   (YYMMDD) */
/* ***CATEGORY NO.  D1A5 */
/* ***KEYWORDS  BLAS,DOUBLE PRECISION,INTERCHANGE,LINEAR ALGEBRA,VECTOR */
/* ***AUTHOR  LAWSON, C. L., (JPL) */
/*           HANSON, R. J., (SNLA) */
/*           KINCAID, D. R., (U. OF TEXAS) */
/*           KROGH, F. T., (JPL) */
/* ***PURPOSE  Interchange d.p. vectors */
/* ***DESCRIPTION */

/*                B L A S  Subprogram */
/*    Description of Parameters */

/*     --Input-- */
/*        N  number of elements in input vector(s) */
/*       DX  double precision vector with N elements */
/*     INCX  storage spacing between elements of DX */
/*       DY  double precision vector with N elements */
/*     INCY  storage spacing between elements of DY */

/*     --Output-- */
/*       DX  input vector DY (unchanged if N .LE. 0) */
/*       DY  input vector DX (unchanged if N .LE. 0) */

/*     Interchange double precision DX and double precision DY. */
/*     For I = 0 to N-1, interchange  DX(LX+I*INCX) and DY(LY+I*INCY), */
/*     where LX = 1 if INCX .GE. 0, else LX = (-INCX)*N, and LY is */
/*     defined in a similar way using INCY. */
/* ***REFERENCES  LAWSON C.L., HANSON R.J., KINCAID D.R., KROGH F.T., */
/*                 *BASIC LINEAR ALGEBRA SUBPROGRAMS FOR FORTRAN USAGE*, */
/*                 ALGORITHM NO. 539, TRANSACTIONS ON MATHEMATICAL */
/*                 SOFTWARE, VOLUME 5, NUMBER 3, SEPTEMBER 1979, 308-323 */
/* ***ROUTINES CALLED  (NONE) */
/* ***END PROLOGUE  DSWAP */

/* ***FIRST EXECUTABLE STATEMENT  DSWAP */
    /* Parameter adjustments */
    --dy;
    --dx;

    /* Function Body */
    if (*n <= 0) {
	return 0;
    }
    if (*incx == *incy) {
	if ((i__1 = *incx - 1) < 0) {
	    goto L5;
	} else if (i__1 == 0) {
	    goto L20;
	} else {
	    goto L60;
	}
    }
L5:

/*       CODE FOR UNEQUAL OR NONPOSITIVE INCREMENTS. */

    ix = 1;
    iy = 1;
    if (*incx < 0) {
	ix = (-(*n) + 1) * *incx + 1;
    }
    if (*incy < 0) {
	iy = (-(*n) + 1) * *incy + 1;
    }
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dtemp1 = dx[ix];
	dx[ix] = dy[iy];
	dy[iy] = dtemp1;
	ix += *incx;
	iy += *incy;
/* L10: */
    }
    return 0;

/*       CODE FOR BOTH INCREMENTS EQUAL TO 1 */


/*       CLEAN-UP LOOP SO REMAINING VECTOR LENGTH IS A MULTIPLE OF 3. */

L20:
    m = *n % 3;
    if (m == 0) {
	goto L40;
    }
    i__1 = m;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dtemp1 = dx[i__];
	dx[i__] = dy[i__];
	dy[i__] = dtemp1;
/* L30: */
    }
    if (*n < 3) {
	return 0;
    }
L40:
    mp1 = m + 1;
    i__1 = *n;
    for (i__ = mp1; i__ <= i__1; i__ += 3) {
	dtemp1 = dx[i__];
	dtemp2 = dx[i__ + 1];
	dtemp3 = dx[i__ + 2];
	dx[i__] = dy[i__];
	dx[i__ + 1] = dy[i__ + 1];
	dx[i__ + 2] = dy[i__ + 2];
	dy[i__] = dtemp1;
	dy[i__ + 1] = dtemp2;
	dy[i__ + 2] = dtemp3;
/* L50: */
    }
    return 0;
L60:

/*     CODE FOR EQUAL, POSITIVE, NONUNIT INCREMENTS. */

    ns = *n * *incx;
    i__1 = ns;
    i__2 = *incx;
    for (i__ = 1; i__2 < 0 ? i__ >= i__1 : i__ <= i__1; i__ += i__2) {
	dtemp1 = dx[i__];
	dx[i__] = dy[i__];
	dy[i__] = dtemp1;
/* L70: */
    }
    return 0;
} /* dswap_ */

