/* tqlrat.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b13 = 1.;

/* Subroutine */ int tqlrat_(n, d__, e2, ierr)
integer *n;
doublereal *d__, *e2;
integer *ierr;
{
    /* Initialized data */

    static doublereal machep = 1.;

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    double sqrt(), d_sign();

    /* Local variables */
    static doublereal b, c__, f, g, h__;
    static integer i__, j, l, m;
    static doublereal p, r__, s;
    static integer l1, ii;
    extern doublereal pythag_();
    static integer mml;

/* ***BEGIN PROLOGUE  TQLRAT */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4A5,D4C2A */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Computes eigenvalues of symmetric tridiagonal matrix */
/*            a rational variant of the QL method. */
/* ***DESCRIPTION */

/*     This subroutine is a translation of the ALGOL procedure TQLRAT, */
/*     ALGORITHM 464, COMM. ACM 16, 689(1973) by Reinsch. */

/*     This subroutine finds the eigenvalues of a SYMMETRIC */
/*     TRIDIAGONAL matrix by the rational QL method. */

/*     On Input */

/*        N is the order of the matrix. */

/*        D contains the diagonal elements of the input matrix. */

/*        E2 contains the squares of the subdiagonal elements of the */
/*          input matrix in its last N-1 positions.  E2(1) is arbitrary. */

/*      On Output */

/*        D contains the eigenvalues in ascending order.  If an */
/*          error exit is made, the eigenvalues are correct and */
/*          ordered for indices 1,2,...IERR-1, but may not be */
/*          the smallest eigenvalues. */

/*        E2 has been destroyed. */

/*        IERR is set to */
/*          Zero       for normal return, */
/*          J          if the J-th eigenvalue has not been */
/*                     determined after 30 iterations. */

/*     Calls PYTHAG(A,B) for sqrt(A**2 + B**2). */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  PYTHAG */
/* ***END PROLOGUE  TQLRAT */


    /* Parameter adjustments */
    --e2;
    --d__;

    /* Function Body */
/* ***FIRST EXECUTABLE STATEMENT  TQLRAT */
    if (machep != 1.) {
	goto L10;
    }
L5:
    machep *= .5;
    if (machep + 1. > 1.) {
	goto L5;
    }
    machep *= 2.;

L10:
    *ierr = 0;
    if (*n == 1) {
	goto L1001;
    }

    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
/* L100: */
	e2[i__ - 1] = e2[i__];
    }

    f = 0.;
    b = 0.;
    e2[*n] = 0.;

    i__1 = *n;
    for (l = 1; l <= i__1; ++l) {
	j = 0;
	h__ = machep * ((d__1 = d__[l], abs(d__1)) + sqrt(e2[l]));
	if (b > h__) {
	    goto L105;
	}
	b = h__;
	c__ = b * b;
/*     .......... LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT .......... */
L105:
	i__2 = *n;
	for (m = l; m <= i__2; ++m) {
	    if (e2[m] <= c__) {
		goto L120;
	    }
/*     .......... E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT */
/*                THROUGH THE BOTTOM OF THE LOOP .......... */
/* L110: */
	}

L120:
	if (m == l) {
	    goto L210;
	}
L130:
	if (j == 30) {
	    goto L1000;
	}
	++j;
/*     .......... FORM SHIFT .......... */
	l1 = l + 1;
	s = sqrt(e2[l]);
	g = d__[l];
	p = (d__[l1] - g) / (s * 2.);
	r__ = pythag_(&p, &c_b13);
	d__[l] = s / (p + d_sign(&r__, &p));
	h__ = g - d__[l];

	i__2 = *n;
	for (i__ = l1; i__ <= i__2; ++i__) {
/* L140: */
	    d__[i__] -= h__;
	}

	f += h__;
/*     .......... RATIONAL QL TRANSFORMATION .......... */
	g = d__[m];
	if (g == 0.) {
	    g = b;
	}
	h__ = g;
	s = 0.;
	mml = m - l;
/*     .......... FOR I=M-1 STEP -1 UNTIL L DO -- .......... */
	i__2 = mml;
	for (ii = 1; ii <= i__2; ++ii) {
	    i__ = m - ii;
	    p = g * h__;
	    r__ = p + e2[i__];
	    e2[i__ + 1] = s * r__;
	    s = e2[i__] / r__;
	    d__[i__ + 1] = h__ + s * (h__ + d__[i__]);
	    g = d__[i__] - e2[i__] / g;
	    if (g == 0.) {
		g = b;
	    }
	    h__ = g * p / r__;
/* L200: */
	}

	e2[l] = s * g;
	d__[l] = h__;
/*     .......... GUARD AGAINST UNDERFLOW IN CONVERGENCE TEST .......... */
	if (h__ == 0.) {
	    goto L210;
	}
	if ((d__1 = e2[l], abs(d__1)) <= (d__2 = c__ / h__, abs(d__2))) {
	    goto L210;
	}
	e2[l] = h__ * e2[l];
	if (e2[l] != 0.) {
	    goto L130;
	}
L210:
	p = d__[l] + f;
/*     .......... ORDER EIGENVALUES .......... */
	if (l == 1) {
	    goto L250;
	}
/*     .......... FOR I=L STEP -1 UNTIL 2 DO -- .......... */
	i__2 = l;
	for (ii = 2; ii <= i__2; ++ii) {
	    i__ = l + 2 - ii;
	    if (p >= d__[i__ - 1]) {
		goto L270;
	    }
	    d__[i__] = d__[i__ - 1];
/* L230: */
	}

L250:
	i__ = 1;
L270:
	d__[i__] = p;
/* L290: */
    }

    goto L1001;
/*     .......... SET ERROR -- NO CONVERGENCE TO AN */
/*                EIGENVALUE AFTER 30 ITERATIONS .......... */
L1000:
    *ierr = l;
L1001:
    return 0;
} /* tqlrat_ */

