#ifndef PARSEPROC_H
#define PARSEPROC_H

static void   set_defaults(void);
static int    get_cmd_fnams(int,char**),open_par_fil(void),
              get_tokens(void),         get_aggr_key(void),
              proc_end(void),           close_par_fil(void);
static char   get_data_list(void);
static char * get_line(void);           
static char * alloc_copy(char *);           
static void   realloc_arrs(void),       realloc_toks(int),
              free_arrs(void),
              chk_fil(char *),          chk_stor(int,int),
              chk_seeds(void);
static int    chk_stat(void),           chk_repeat(void),
              chk_trait(void),          chk_int_trait(void),
              chk_ff(int),
              chk_sel_tr(void),         chk_start_ff(int),
              chk_levels_ff(void),      chk_var(void),
              chk_covar(void),          chk_covar_i(void),
              chk_sim(int,int),         chk_unlnkd(void),
              chk_map(int,int,int),     chk_vmap(int,int),
              chk_locus(int,int),       chk_means(void),
              chk_vari(void),           chk_mrkdat(int),
              chk_prbgam(int),          chk_wind(int),
              chk_kinshp(int, int),     chk_reco_frq(void);

static SIM_PTR     chk_sim_node(int),        alloc_sim_node(int);
static UNLNKD_PTR  alloc_unlnkd_node(int);
static MAP_PTR     chk_map_node(int,int,int),
                   alloc_map_node(int,int,int);
static VMAP_PTR    chk_vmap_node(int,int,int),
                   alloc_vmap_node(int,int);
static LOCUS_PTR   chk_locus_node(int,int,int),
                   alloc_locus_node(int,int,int),
                   alloc_dflt_locus_node(int,int,int),
                   alloc_locus_nodex(int,int,int);
static MEANS_PTR   chk_means_node(int) ,     alloc_means_node(int);
static FREQ_PTR    alloc_frq(void),          alloc_dflt_frq(void),
                   alloc_frqx(int);
static VARI_PTR    chk_vari_node(int,int),   alloc_vari_node(int,int);
static MARKDAT_PTR chk_mrkdat_node(int),     alloc_mrkdat_node(int);
static LOCWND_PTR  chk_wind_node(int);
static KINS *      chk_kinshp_node(int, int);
static PROBGAM_PTR alloc_prbgam_node(int);
static LOCWND_PTR  alloc_wind_node(int);
static KINS *      alloc_kinshp_node(int, int);

static void   alloc_dist(MAP_PTR,int),  alloc_vdist(VMAP_PTR,int),
              alloc_mrkdat_list(MARKDAT_PTR),
              alloc_nams_list (KINS *),
              alloc_prbgam_list(PROBGAM_PTR),
              init_vmap_lists(VMAP_PTR),
              stor_sim_data(SIM_PTR,int,int),
              stor_unlnkd(int,UNLNKD_PTR),
              stor_map_data(MAP_PTR,int,int,int),
              stor_vmap_data(VMAP_PTR,int,int),
              stor_frq(FREQ_PTR),
              stor_dflt_frq(FREQ_PTR),
              stor_locus_data(int,LOCUS_PTR,FREQ_PTR,int,int),
              stor_dflt_locus_data(int,int,LOCUS_PTR,FREQ_PTR),
              stor_mean_data(int,MEANS_PTR),
              stor_dflt_mean_data(int,MEANS_PTR),
              stor_vari_data(int,VARI_PTR),
              stor_dflt_vari_data(int,VARI_PTR),
              stor_mrkdat(MARKDAT_PTR,int),
              stor_prbgam(PROBGAM_PTR,int),
              stor_wind(LOCWND_PTR,int),
              stor_kinshp(KINS *, int, int),
              stor_reco_frq(int *, double *),
              free_unlnkd(void),        free_dist(MAP_PTR),
              free_vdist(VMAP_PTR, int),free_freq(LOCUS_PTR),
              free_mrkdat_list(MARKDAT_PTR),
              free_nams_list (KINS *),  free_reco_frq(double **);
static int    compar_mkid_d(const void *, const void *);
static double * alloc_reco_frq(void);
static void   reset_sel_tr(void),       reset_start_ff(int),
              reset_start_var(int),     reset_start_cov(int),
              reset_fit_var(int),       reset_fit_cov(int),
              reset_set_eigen(void),
              set_sel_tr(int),          set_start_ff(int),
              set_start_var(int),       set_start_cor(int),
              set_start_cov(int),       set_fit_cov(int),
              set_set_eigen(void);

/* parsedef.h code  count variable           data arrays
   ...............  ..............           ...........
        "i"         ni_par                   j_par
        "k"         nk_par                     "
        "h"         nh_par                   u_par
        "r"         nr_par                   d_par
        "x"         nx_par                     "
        "n"         nm_par                   m_par
        "g"         nm_par, nk_par           m_par, j_par
        "a"         ni_par, nm_par, nk_par   j_par, m_par
        "s"         ns_par                   s_par
 */
static int      max_npar, max_tchar;
static int      ni_par, nk_par, nh_par, nr_par, nx_par, nm_par, ns_par;
static int    * j_par;                  /* integers              */
static uint32 * u_par;                  /* hexadecimal no.s      */
static double * d_par;                  /* doubles               */
static char  ** m_par;                  /* names                 */
static char     s_par[MAXLINLEN+2];     /* string                */
static int      prntd_flg;  

#endif /*PARSEPROC_H*/
