
#ifndef SAMPLE_H
#define SAMPLE_H

GLOBAL int **xx0, **xx1;      /* arrays of maternal and paternal segregation
                                 indicators at all the loci                  */
GLOBAL int **gg0, **gg1;      /* arrays of all labelled founder genes in 
                                 the pedigree                                */

                              /* (note: NLoci is NMarks + NTraits)           */
GLOBAL int ** chromo;         /* [nh+1][NLoci]  indices of loci in ordered
                               * chromosome, for each set of recomb values   */
GLOBAL int ** revchro;        /* [nh+1][NLoci]  positions of loci in ordered
                               * chromosome --  "inverse" of chromo[][]:
                               * (chromo[][pos] = nam, revchro[][nam] = pos) */
GLOBAL double *** xecomo;     /* [2][nh+1][NLoci]  sex-valued recombinations
                               * in ordered chromosome                       */

void  allocate_loci (int, int *, double **);
int   check_seg_mode (void);
void  set_seg_mode (int);
int   set_genes (int);
double seg_pen2 (int, int ***, double *, int, int, int *);

#endif
