 
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/*       stuff.h:  header file for Stuff/                              */
/*                 this header file includes:                          */
/*                    data structures for Stuff/ functions             */
/*                    function prototyes for Stuff/ functions          */
/*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

#ifndef STUFF_H
#define STUFF_H 

#include "incs.h"

#define DATASINK "/dev/null"

#define WHERE    __FILE__, __LINE__

GLOBAL int nWarns;                      /*total no. of warnings issued  */

                                        /*table of program codes vs.    */
                                        /*functions to be called        */
                                        /*(program codes defined in     */
                                        /*Filtab[] in globs.h           */
struct _cleanup {                       /*table contents defined in     */
       char * pcods;                    /*main program headers)         */
       void (* func) (void);
                };
GLOBAL struct _cleanup * PCleanUp;
                                        /*function prototypes for       */
                                        /*Stuff/ library:               */
int qfunc_doub  (const void *, const void *);
int qfunc_int   (const void *, const void *);

void alloc_chk       (char *, int, void *);
void give_warn       (int, ...);
void give_warn_where (char *, int, int, ...);
void give_err        (int, ...);
void give_err_where  (char *, int, int, ...);
void give_up         (int, ...);
void give_up_where   (char *, int, int, ...);

void print_head (char *),            print_tail (void);
void printhost  (void); 
void print_val  (double),            print_val5 (double);
int  intWid     (int, int),          decWid     (double, double, int); 
int  fldWid     (double, double, int);
char * dub2nlz  (double, int, int);
int max         (int, int),          min        (int, int);
double dist2rf  (double),            rf2dist    (double);
double gendist  (double),            recomb     (double);

FILE * open_fil (char *);
FILE * open_ped (void);
FILTAB_PTR get_filent (char *);
FILTAB_PTR get_filtyp (char);
void   free_fnam (FILTAB_PTR);
void   free_fnams (void);
void   free_drop (void);
void   free_auto (void);
void   free_marek (void);
void   free_dub (void);
void   clean_morg (void);

/* Allocate 2D or 3D arrays and initialize array elements to 0 or 0.0 */
int     **alloc_int2d (int, int);
int    ***alloc_int3d (int, int, int);
double  **alloc_dbl2d (int, int);
double ***alloc_dbl3d (int, int, int);
/* Free arrays, assign null to pointer */
void          free_2d (void ***, int);
void          free_3d (void ****, int, int);   

/* Return the map position (in cM) of current (varying) trait
 * pos = 0 .. NTPos - 2 */
double map_position (int pos, int sex);

/* Given matrices of likelihood ratios, compute and print lod scores */
void print_lods (double ***);

#endif  /*STUFF_H*/
