/* --------------------------------------------------------------------------- *
 *       pr_npatsets(), pr_pgamset(),   pr_cmpnthead(), pr_probhead(),         *
 *       pr_lochead(),  pr_wndwhead(),  pr_locprob(),   pr_wndwprob()          *
 * --------------------------------------------------------------------------- *
 */
#include "msample.h"

int   pr_npatsets (int *npt)
{
   /* prints number of pattern sets for specified number of gametes  */

   int   j, k, c, s;
   int   nl = 0;

   if (npt[MxGam] > 0)
      nl = log10 ((double) npt[MxGam]) + 1.;

   printf ("  Number of pattern sets to be scored:\n");
   for (j = 1; j <= MxGam; ++j)
   {
      k = 0;
      for (c = 0; c < n_compnts; ++c)
         for (s = 0; s < NScSet[c]; ++s)
            if (j == NPrGam[c][s])
               k = 1;
      if (k)
         printf ("    on %2d gametes:  %*d \n", j, nl, npt[j]);
   }
   printf ("\n\n");
   fflush (stdout);

   /* returns max no. characters for label  */

   return nl > 5 ? nl : 5;
}

void  pr_pgamset (int c, int s)
{
   /* prints proband gametes for specified component and set  */

   int   i, nc = 0;

   if (NScSet[c])
   {
      fprintf (stdout, "       Proband gamete set %d:", s + 1);
      for (i = 0; i < NPrGam[c][s]; ++i)
      {
         nc = nc + strlen (ProbNam[c][s][i]) + 4;
         if (nc > 50)
         {
            fprintf (stdout, "\n                            ");
            nc = 0;
         }
         fprintf (stdout, "  %s", ProbNam[c][s][i]);
         fprintf (stdout, " %d", ProbGam[c][s][i]);
      }
      fprintf (stdout, "\n");
      fflush (stdout);
   }
   return;
}
void  pr_cmpnthead (int c)
{
   /* prints heading for component  */

   printf ("\n Summary for component %d:\n\n", c + 1);

   return;
}
void  pr_probhead (void)
{
   /* prints heading for ibd patterns  */

   printf ("    Probabilities of ibd patterns\n\n");

   return;
}
int   pr_lochead (int c, int s, int **chromo, int mxl)
{
   /* prints column headings for specified component and set  */

   int   i, j;

   for (j = 0; j < NLoci; ++j)
   {
      if (!(j % 8))
      {
         printf ("\n      ");
         for (i = 4; i < MxGam; ++i)
            printf ("  ");
         if (j == 0)
            printf (" pattern  ");
         else
            printf ("          ");
      }
      if (chromo[0][j] == 0)
         printf (" trait ");
      else
         printf ("mark%2d ", chromo[0][j]);
      if (j == NLoci - 1)
      {
         for (i = 5; i < mxl; ++i)
            printf (" ");
         printf (" label\n");
      }
   }
   return MxGam > 4 ? MxGam : 4;
}
void  pr_locprob (int c, int s, int ng, int *gaga, double *p, int lab, int mxl,
                  int mxi)
{
   /* prints data for specified component and set  */

   int   i, j;

   for (j = 0; j < NLoci; ++j)
   {
      if (!(j % 8))
      {
         printf ("\n       ");
         for (i = 0; i < mxi - ng; ++i)
            printf ("  ");
         if (j == 0)
            for (i = 0; i < ng; ++i)
               printf ("%d ", gaga[i]);
         else
            for (i = 0; i < ng; ++i)
               printf ("  ");
      }
      printf ("%s", dub2nlz (p[j], 7, 4));
      if (j == NLoci - 1)
         printf ("  %*d", mxl, lab);
   }
}
void  pr_wndwhead (int nw)
{
   int   i, j;

   for (j = 0; j < nw; ++j)
   {
      if (!(j % 8))
      {
         printf ("\n      ");
         for (i = 2; i < LocWndw; ++i)
            printf ("  ");
         if (j == 0)
            printf (" ibd ");
         else
            printf ("     ");
      }
      printf (" wndw%2d", j + 1);
   }
   printf ("\n");

   return;
}
void  pr_wndwprob (int c, int s, int nw, int p, int *g, double ****ns)
{
   int   i, j;

   for (j = 0; j < nw; ++j)
   {
      if (!(j % 8))
      {
         printf ("\n       ");
         for (i = 0; i < LocWndw; ++i)
            if (j == 0)
               printf ("%d ", g[i]);
            else
               printf ("  ");
      }
      printf ("%s", dub2nlz (ns[c][s][j][p] / NIt, 7, 4));
   }
   return;
}
