/* set_markdat(), set_traitdat(), set_probgam()               MAJ Aug/01   */
/* moved to Msample library.                                  EAT Feb 02   */
/* set_markdat() moved to set_traits.c                        EAT Mar 02   */

#include "msample.h"

void  set_traitdat (int ***yy, int *qdex, int *trtphen, int pdsz, int nc)
{
   int   c, k, i, np, kfound, ifound;

   char *k_txt[5] =
   {
      "",
      "(homozygous normal) ",
      "(phenotypic normal for recessive trait, not implemented)",
      "(recessive carrier) ",
      "(recessive affected)"
   };

   printf ("\n Trait data:\n");

   for (c = 0; c < nc; ++c)
   {
      kfound = 0;
      printf ("\n Component %d:\n", c + 1);
      for (k = 4; k > 0; --k)           /* k=0 unknown        */
      {
         ifound = 0;
         np = 0;
         for (i = 0; i < pdsz; ++i)
         {
            if (nghd[i].component == c + 1 && data[i][5] == k)
            {
               if (TraitPheno)          /* ADDED CODE, EAT 9/00 & 10/00 */
               {
                  ++np;
                  qdex[i] = np;
                  trtphen[i] = data[i][5];
                  if (!kfound)
                     kfound = 1;
                  if (!ifound)
                     printf ("    phenotype %d %s:",
                             trtphen[i], k_txt[k]);
                  if (ifound && !(ifound % 8))
                     printf ("\n                                      ");
                  ++ifound;
                  printf (" %s", nghd[i].self);
               }
               else
               {
                  if (k == 4)           /* recessive affected */
                  {
                     yy[0][0][i] = 2;
                     yy[1][0][i] = 2;
                  }
                  if (k == 3)           /* recessive carrier  */
                  {
                     yy[0][0][i] = 1;
                     yy[1][0][i] = 2;
                  }
                  if (k == 1)           /*  homozyyg normal    */
                  {
                     yy[0][0][i] = 1;
                     yy[1][0][i] = 1;
                  }
                  if (k == 2)           /* phenotypic normal for */
                     continue;          /* recessive trait not implemented */
                  else
                  {
                     kfound = 1;
                     if (!ifound)
                        printf ("    genotype %d %d %s:",
                                yy[0][0][i], yy[1][0][i], k_txt[k]);
                     if (ifound && !(ifound % 8))
                        printf ("\n                                      ");
                     ++ifound;
                     printf (" %s", nghd[i].self);
                  }
               }
            }
         }
         if (ifound)
            printf ("\n");
      }
      if (!kfound)
         printf ("    no trait data\n");
   }
   printf ("\n\n");
   fflush (stdout);

   return;
}

void  set_probgam (int nc)
{
   int   c, s, i, posp;

   for (c = 0; c < nc; ++c)
      if (NScCmp < c + 1)
         give_up (ERA_ncd, c + 1);

      else if (!NScSet[c])
         give_up (ERA_ncd, c + 1);

      else
         for (s = 0; s < NScSet[c]; ++s)
            for (i = 0; i < NPrGam[c][s]; ++i)
            {
               if ((posp = get_posit (ProbNam[c][s][i])) == INVALID_INDEX)
                  give_up (ERA_inp, ProbNam[c][s][i]);
               else if ((nghd[posp].component) != (c + 1))
                  give_up (ERA_pnc, ProbNam[c][s][i], c + 1,
                           nghd[posp].component);

               ProbIx[c][s][i] = posp;
            }
   if (NScCmp > nc)
      give_warn (ERA_mcd, NScCmp, nc);

   return;
}
