
/*
 * proc_seeds() calls functions to set parameters for seeds
 */

int   proc_seeds (void)
{
   if (!test_seeds ())
      if (proc_err ())
         return FALSE;

   if (!test_oseeds ())
      if (proc_err ())
         return FALSE;

   if (n_err)
      return proc_end ();

   return TRUE;
}

/* --------- test fncs:  test results of processing seed statements -------- */

int   test_seeds (void)

/* determines whether seeds were given */

{
   if (pmx->pcod == 'd')
   {
      if (!MarkSeedSet)                 /* tests for marker seeds set        */
      {
         MarkSeedC = CONGRUENTIAL_SEED;
         MarkSeedT = TAUSWORTHE_SEED;
         err_typ = ERD_SSD;
      }

/*    fprintf(stdout,"\n Hexadecimal marker seeds:  %#x %#x\n\n", 
 *            MarkSeedC, MarkSeedT);                                         */

      if (!TraitSeedSet)                /* tests for trait seeds set         */
      {
         TraitSeedC = 0;
         TraitSeedT = 0;
      }
      else if (NTraits)
         ;
/*       fprintf(stdout,"\n Hexadecimal trait seeds:  %#x %#x\n\n",
 *               TraitSeedC, TraitSeedT); */
      fflush (stdout);
   }

   if (pmx->pcod == 'a' || pmx->pcod == 'l' || pmx->pcod == 's'
       || pmx->pcod == 'i')
   {
      if (!SamplSeedSet)                /*tests for sampler seeds set        */
      {
         SamplSeedC = CONGRUENTIAL_SEED;
         SamplSeedT = TAUSWORTHE_SEED;
         err_typ = ERD_SSS;
      }

/*    fprintf(stdout,"\n Hexadecimal sampler seeds:  %#x %#x\n\n", 
 *            SamplSeedC, SamplSeedT); */

      fflush (stdout);
   }

   if (!err_typ)
      return TRUE;
   else
      return FALSE;
}

int   test_oseeds (void)
{
   pft = get_filent (OSEED);

   if (pmx->pcod == 'd')
   {
      if (pft->fname && !MarkSeedsOut && !TraitSeedsOut)
      {
         if (NLoci - NTraits)
            MarkSeedsOut = Y;
         if (NTraits)
            TraitSeedsOut = Y;
      }
      if (!pft->fname && MarkSeedsOut)
      {
         MarkSeedsOut = N;
         err_typ = ERD_OSM;
      }
      if (!pft->fname && TraitSeedsOut)
      {
         TraitSeedsOut = N;
         err_typ = ERD_OST;
      }
   }
   if (pmx->pcod == 'a' || pmx->pcod == 'l' || pmx->pcod == 'i'
       || pmx->pcod == 's')
      if (pft->fname)
         SamplSeedsOut = Y;
      else
         SamplSeedsOut = N;

   if (!err_typ)
      return TRUE;
   else
      return FALSE;
}
