/*  vim: sw=3
 *  $Id: print_lods.c,v 1.1 2002/04/29 23:04:22 nali Exp $ */

#include "stuff.h"
#include "quant.h"

void  print_lods (double ***lkratios)
{
   /* Global variables used */
   extern int n_compnts;
   extern int NTPos;

   double **lods = NULL;                    /* Lods scores */
   double lodsval[4];
   double eigen2 = 0.0;
   int   c, i, m;

   lods = alloc_dbl2d (3, NTPos - 1);

   printf ("\n\n ESTIMATED LODS SCORES\n");

   for (c = 0; c < n_compnts; ++c)
   {
      printf ("  Component %3d\n", c + 1);
      for (m = 0; m < 3; ++m)
      {
         lodsval[m] = comput_lods (lkratios[c], lods[m],
                                   NTPos - 1, m, &eigen2);
         if (m == 0)
         {
            lodsval[3] = eigen2;
         }
      }
      printf ("\n    The largest eigenvalue:        %8.6f\n", lodsval[0]);
      printf ("\n    The second largest eigenvalue: %8.6f\n", lodsval[3]);
      printf ("\n    Cumulative from left  :        %8.6f\n", lodsval[1]);
      printf ("\n    Cumulative from right :        %8.6f\n", lodsval[2]);
      printf ("\n    LOD scores:\n");
      printf ("  %10s %10s %10s %10s %10s %10s\n", "position",
              "female", "male", "eigen", "left", "right");
      for (i = 0; i < NTPos - 1; ++i)
      {
         printf ("  %10d", i);
         printf (" %10.5f %10.5f",
                 map_position (i, FEM), map_position (i, MAL));
         for (m = 0; m < 3; ++m)
         {
            printf (" %10.5f", lods[m][i]);
         }
         putchar ('\n');
      }
      putchar ('\n');
      fflush (stdout);
   }

   free_2d ((void *) &lods, 3);
}
