
/*  functions are:
 *       intWid(min, max)         - returns no. of chars for writing 
 *                                  integers in range of min and max
 *       decWid(min, max, sigfig) - returns no. of decimal places to write 
 *                                  doubles in specified range and with
 *                                  a max. of "sigfig: significant figures
 *       fldWid(min, max, dec) -    returns no. of characters to write 
 *                                  doubles in specified range and with "dec"
 *                                  decimal places
 */

#include "stuff.h"

int   intWid (int min, int max)
{
   int   n, m;

   n = min < 0 ? floor (log10 ((double) (-min))) + 2 : 1;
   m = max > 0 ? floor (log10 ((double) max)) + 1 : 1;

   return (m > n ? m : n);
}

int   decWid (double dmin, double dmax, int sigfig)
{
   int   n, m, p;

   dmin = dmin < 0. ? -dmin : dmin;
   n = dmin == 0. ? 0 : floor (log10 (dmin)) + 1;
   dmax = dmax < 0. ? -dmax : dmax;
   m = dmax == 0. ? 0 : floor (log10 (dmax)) + 1;
   p = sigfig - (m > n ? m : n);

   return (p > 0 ? p : 0);
}
int   fldWid (double dmin, double dmax, int dec)
{
   int   n, m;

   n = dmin < 0. ? floor (log10 (-dmin)) + 1 : 1;
   n = n < 0 ? 1 : n;
   n = dmin < 0 ? n + 1 : n;
   m = dmax > 0. ? floor (log10 (dmax)) + 1 : 1;

   return (m > n ? m + dec + 1 : n + dec + 1);
}
